@@PACKAGE_NAME_COMPLETE_@@PaCO_@@INTERFACE_NAME@@::PaCO_@@INTERFACE_NAME@@(@@INTERFACE_NAME@@_var obj) : _object(obj) {}

@@PACKAGE_NAME_COMPLETE_@@@@INTERFACE_NAME@@_var
@@PACKAGE_NAME_COMPLETE_@@PaCO_@@INTERFACE_NAME@@::PaCO_unarrow()
{
    return _object;
}

@@PACKAGE_NAME_COMPLETE_@@PaCO_@@INTERFACE_NAME@@ *
@@PACKAGE_NAME_COMPLETE_@@PaCO_@@INTERFACE_NAME@@::PaCO_narrow(CORBA::Object_ptr obj, CORBA::ORB_ptr orb)
{
  @@PACKAGE_NAME_COMPLETE_@@PaCO_@@INTERFACE_NAME@@ * stub = NULL;
  // Take the orb
  // int argc = 0;
  // CORBA::ORB_var orb = CORBA::ORB_init(argc,NULL);

  // Connection to the interface manager
  PaCO::ParallelKernel_var interface_manager = PaCO::ParallelKernel::_narrow(obj);
  if (CORBA::is_nil(interface_manager))
    {
      // The server is a sequential server
      stub = new PaCO_output_stub_@@INTERFACE_NAME@@(@@INTERFACE_NAME@@::_narrow(obj), orb);
    }
  else
    {
      // The server is a PaCO++ server
      PaCO::ConnectionInfos_var connections = interface_manager->getConnectionInfos();
      // Create the PaCO++ layer
      @@PACKAGE_NAME_COMPLETE_@@PaCO_parallel_layer_@@INTERFACE_NAME@@ * parallel_stub = new @@PACKAGE_NAME_COMPLETE_@@PaCO_parallel_layer_@@INTERFACE_NAME@@(connections->serveur_topo, @@INTERFACE_NAME@@::_narrow(obj), orb);
      parallel_stub->setRealStubs( new (@@PACKAGE_NAME_COMPLETE_@@@@INTERFACE_NAME@@_PaCO_ptr) [(int) connections->nodes.length()] );
      parallel_stub->setNumberStubs( (int) connections->nodes.length() );
      for(int j = 0; j < (int) connections->nodes.length();j++)
	{
	  CORBA::String_var string = connections->nodes[j];
	  CORBA::Object_var _obj =  orb->string_to_object(string);
	  parallel_stub->setRefRealStubs(j, @@INTERFACE_NAME@@_PaCO::_narrow(_obj));
	}
      stub = parallel_stub;

      // Client id
      PaCO_operation * global_ptr = stub->getContext("global_paco_context");
      global_ptr->setClientId(connections->request_uid);
    }
  return stub;
}

@@PACKAGE_NAME_COMPLETE_@@PaCO_parallel_layer_@@INTERFACE_NAME@@::PaCO_parallel_layer_@@INTERFACE_NAME@@(PaCO::PacoTopology_t serveur_topo, @@INTERFACE_NAME@@_var obj, CORBA::ORB_ptr _orb) : PaCO_@@INTERFACE_NAME@@(obj)
{
  orb = _orb;
  @@CONS_PARALLEL_LAYER@@
}

@@PACKAGE_NAME_COMPLETE_@@PaCO_parallel_layer_@@INTERFACE_NAME@@::~PaCO_parallel_layer_@@INTERFACE_NAME@@()
{
  @@DES_PARALLEL_LAYER@@
}

void
@@PACKAGE_NAME_COMPLETE_@@PaCO_parallel_layer_@@INTERFACE_NAME@@::setRealStubs(@@INTERFACE_NAME@@_PaCO_ptr * _real_stubs)
{
  if (_real_stubs != NULL )
  {
    real_stubs = _real_stubs;
  }
}

void 
@@PACKAGE_NAME_COMPLETE_@@PaCO_parallel_layer_@@INTERFACE_NAME@@::setRefRealStubs(int i, @@INTERFACE_NAME@@_PaCO_ptr obj)
{
  if ( i < number_stubs )
  {
    real_stubs[i] = obj;
  }
}
  
void 
@@PACKAGE_NAME_COMPLETE_@@PaCO_parallel_layer_@@INTERFACE_NAME@@::setNumberStubs(int _number_stubs)
{
  if (_number_stubs > 0)
  {
    number_stubs = _number_stubs;
  }
}

PaCO_operation * 
@@PACKAGE_NAME_COMPLETE_@@PaCO_parallel_layer_@@INTERFACE_NAME@@::getContext(string method_name)
{
    @@CONTEXT@@
    else
    {	
	return NULL;
    }
}

@@METHODS_CC@@

@@PACKAGE_NAME_COMPLETE_@@PaCO_output_stub_@@INTERFACE_NAME@@::PaCO_output_stub_@@INTERFACE_NAME@@(@@INTERFACE_NAME@@_var obj, CORBA::ORB_ptr orb) : PaCO_@@INTERFACE_NAME@@(@@INTERFACE_NAME@@::_duplicate(obj)), _server(obj)
{
  serveur_topo.total = 1;
}

@@PACKAGE_NAME_COMPLETE_@@PaCO_output_stub_@@INTERFACE_NAME@@::~PaCO_output_stub_@@INTERFACE_NAME@@() 
{
}

PaCO_operation * 
@@PACKAGE_NAME_COMPLETE_@@PaCO_output_stub_@@INTERFACE_NAME@@::getContext(string method_name)
{
  @@CONTEXT@@
  return (PaCO_operation*) 0;
}

@@METHODS_OUTPUT_CC@@
