#!/usr/bin/env python

import os,string
import tempfile
import re
 
# ---------------------------------------------------------------------------------------
# This fonction adds gen_file to file, watching !!macros!! of modes
def add_gen_file(file, gen_file, modes=[]):

    end_file = open(file, 'a+')
    gen_file = open(gen_file, 'r')
    # Init regex object
    regex_1 = re.compile('!![^!]*!!')
    
    for s in gen_file.readlines():
	result = regex_1.search(s)
	if result:
            end = 'false'
            add = 'false'
            while end == 'false' :
                add_local = 'false'
                macro = result.group()
                macro = macro[2:-2]
                for compteur in modes:
                    if macro == compteur:
                        add_local = 'true'
                if add_local == 'false' :
                    end = 'true'
                else :
                    s = s[result.end():]
                    result = regex_1.search(s)
                    if result:
                        end = 'false'
                    else :
                        add = 'true'
                        end = 'true'
            if add == 'true':
                end_file.write(s)
	else:
	    # s is not a special line
	    end_file.write(s)
    end_file.close()
    gen_file.close()
# ---------------------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------
# concanate_files permet d'ajouter une liste de fichier dans un seul fichier
# Arg_1 : Le fichier ou l;on veut ajouter d'autre fichier
# Arg_2 : Les fichiers a ajouter
# Arg_3 : Modes for line macro
# Retour : Pas de retour
#def concanate_files(fichier_de_fin, files=[], modes=[]):
#    for compteur in len(files):
#	add_gen_file(fichier_de_fin,files[compteur],modes)
def concanate_files(fichier_de_fin, file, modes=[]):
    add_gen_file(fichier_de_fin,file,modes)

# ---------------------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------
# TwinFile permet de copier un fichier dans un autre fichier
# Arg_1 : Le fichier a copier
# Arg_2 : Le nouveau fichier
# Retour : Pas de retour
def TwinFile(File, TwinFile,modes=[]):
    f = open(File,'r')
    tf = open(TwinFile, 'wr')
    regex_1 = re.compile('!![^!]*!!')
    for s in f.readlines():
	result = regex_1.search(s)
	if result:
            end = 'false'
            add = 'false'
            while end == 'false' :
                add_local = 'false'
                macro = result.group()
                macro = macro[2:-2]
                for compteur in modes:
                    if macro == compteur:
                        add_local = 'true'
                if add_local == 'false' :
                    end = 'true'
                else :
                    s = s[result.end():]
                    result = regex_1.search(s)
                    if result:
                        end = 'false'
                    else :
                        add = 'true'
                        end = 'true'
            if add == 'true':
		tf.write(s)
	else:
	    # s is not a special line
	    tf.write(s)
    f.close()
    tf.close()
# ---------------------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------
# Cette methode permet de remplacer dans le fichier file_name toutes les 
# lignes ayant la macro string_to_change par le fichier new_file
def StringToFile(file_name, string_to_change, new_file, modes=[]):

    TwinFile(file_name,'StringToFile_temp')
    base_file = open(file_name,'wr')
    temp_file = open('StringToFile_temp','r')
    real_new_file = open('real_new_file','wr')
    real_new_file.close()
    concanate_files('real_new_file',new_file, modes)
    for s in temp_file.readlines():
        index = string.find(s,string_to_change)
        if index != -1:
            new_string = open('real_new_file','r')
            for s in new_string.readlines():
                base_file.write(s)
            new_string.close()
        else :
            base_file.write(s)

    base_file.close()
    temp_file.close()
    os.remove('StringToFile_temp')
    os.remove('real_new_file')
# ---------------------------------------------------------------------------------------
    
# ---------------------------------------------------------------------------------------
# StringToString permet de remplacer une chaine dans une autre chaine
# Arg_1 : Le fichier ou l'on doit changer la chaine
# Arg_2 : La chaine a remplacer
# Arg_3 : La nouvelle chaine
# Retour : Pas de retour
def StringToString(File, String, NewString):
    TwinFile(File,'StringToStringTempFile')
    f = open(File,'wr')
    tf = open('StringToStringTempFile','r')

    for s in tf.readlines():
        index = string.find(s,String)
        s_final = ''
        while index != -1:
            s_final = s_final + s[:index] + NewString
            s = s[index+len(String):]
            index = string.find(s,String)
            if index == -1:
                s_final = s_final + s
        if s_final == '':
            f.write(s)
        else:
            f.write(s_final)
    f.close()
    tf.close()
    os.remove('StringToStringTempFile')
# ---------------------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------
# replace_string copie fichier_original dans fichier_de_fin en changeant toutes les chaine_a_changer
# par nouvelle_chaine
# Arg_1 : Le fichier a ajouter
# Arg_2 : Le fichier ou Arg_1 est ajoute
# Arg_3 : La chaine a changer lors de l'ajout
# Arg_4 : La nouvelle chaine
# Retour : Pas de retour
# Rq: s_final permet de gerer s'il y a plusieurs fois chaine_a_changer sur la meme
# ligne
def replace_string(fichier_original, fichier_de_fin, chaine_a_changer, nouvelle_chaine):

    fichier_depart = open(fichier_original, 'r')
    fichier_fin = open(fichier_de_fin, 'wr')
    for s in fichier_depart.readlines():
        index = string.find(s,chaine_a_changer)
        s_final = ''
        while index != -1:
            s_final = s_final + s[:index] + nouvelle_chaine
            s = s[index+len(chaine_a_changer):]
            index = string.find(s,chaine_a_changer)
            if index == -1:
                s_final = s_final + s
        if s_final == '':
            fichier_fin.write(s)
        else:
            fichier_fin.write(s_final)
        
    fichier_depart.close()
    fichier_fin.close()
# ---------------------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------
# permet de chercher une macro dans un fichier de configuration et de rendre
# sa valeur
def search_macro(fichier,chaine):
    macro_val = 'null'
    file = open(fichier,'r')
    for s in file.readlines():
      index = string.find(s,'=')
      s2 = ''
      if index != -1 :
          s2 = s[:index]
      if s2 == chaine:
          index2 = string.find(s,'=')
          macro_val = s[index2+1:-1]      
    return macro_val

def search_macro_complex(fichier,chaine):
    file = open(fichier,'r')
    result = ''
    for s in file.readlines():
        index = string.find(s,chaine+'=')
        if index == 0 :
            index2 = string.find(s,'=')
            result = result + s[index2+1:]
    return result
# ---------------------------------------------------------------------------------------
# string_configuration permits to change a macro in a string
# Arg 1: the string to configure
# Arg 2: macro name
# Arg 3: new string
# Return: the configured string
def string_configuration(str, old_string, new_string):
    
##    str_configured = ""
##    file = open("string_configuration_temp_file", 'wr')
##    file_config = open("string_configuration_temp_configuration_file",'wr')
    
##    file.write(str)
##    s = old_string + "=" + new_string + "\n"
##    file_config.write(s)
    
##    file_config.close()
##    file.close()
##    file_configuration("string_configuration_temp_file","string_configuration_temp_configuration_file")
    
##    file = open("string_configuration_temp_file", 'r')
##    for s in file.readlines():
##	str_configured = str_configured + s
    
##    os.remove("string_configuration_temp_file")
##    os.remove("string_configuration_temp_configuration_file")

    str_configured = ""
    file = open("string_configuration_temp_file", 'wr')
    file.write(str)
    file.close()

    StringToString("string_configuration_temp_file", old_string, new_string)

    file = open("string_configuration_temp_file", 'r')
    for s in file.readlines():
	str_configured = str_configured + s
    os.remove("string_configuration_temp_file")
    return str_configured
# ---------------------------------------------------------------------------------------
# Configure a fichier_de_fin with the configuration file : configfile
def file_configuration(fichier_de_fin, configfile):

    fichier_fin = open(fichier_de_fin, 'r')
    fichier_temp = open('temp_base','wr')
    fichier_conf = open(configfile, 'r')

    for s in fichier_fin.readlines():
        fichier_temp.write(s)

    fichier_temp.close()
    fichier_fin.close()

    for s2 in fichier_conf.readlines():
        index = string.find(s2,'=')
        if index != -1:
            chaine_a_changer = s2[:index]
            nouvelle_chaine = s2[index+1:-1]
            replace_string('temp_base',fichier_de_fin,chaine_a_changer,nouvelle_chaine)

            fichier_fin = open(fichier_de_fin, 'r')
            fichier_temp = open('temp_base', 'wr')

            for s3 in fichier_fin.readlines():
                fichier_temp.write(s3)            

            fichier_fin.close()
            fichier_temp.close()

    fichier_conf.close()
    os.remove('temp_base')
# ---------------------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------
def search_method(fichier_source, class_name, orb):
    fichier = open(fichier_source,'r')

    chaine_trouve = 0
    result = ['    // fct interface\n']
    chaine = class_name
    if orb == 'OMNIORB3':
        chaine = chaine + ' :'
    for s in fichier.readlines():
        if chaine_trouve == 1:
            if string.find(s,'};') != -1:
                chaine_trouve = 0
            else:
                index = string.find(s,' = 0;')
                if index != -1:
                    result.append(s[:index] + ';\n') 
        else:
            index = string.find(s,chaine)
            if index != -1:
                chaine_trouve = 1
    return result
# ---------------------------------------------------------------------------------------

# ---------------------------------------------------------------------------------------
def insert_code_h(fichier_cource_h, code, nom_classe):

    fichier_source = open(fichier_cource_h, 'r')
    fichier_temp = open('fichier_temp_insert_code_h','wr')
    code_a_inserer = open(code, 'r')

    # init : copie du fichier source dans temp
    for s in fichier_source.readlines():
        fichier_temp.write(s)
    fichier_temp.close()
    fichier_source.close()

    # recherche et insertion du code
    fichier_temp = open('fichier_temp_insert_code_h','r')
    fichier_source = open(fichier_cource_h, 'r+')
    
    chaine = 'class ' + nom_classe 

    etape = 'cherche_classe'
    for s in fichier_temp.readlines():
        if etape == 'cherche_classe':
            if string.find(s,chaine+ ' :') != -1:
                etape = 'cherche_debut_classe'
                chaine = '{\n'
                fichier_source.write(s)
            elif string.find(s,chaine+ ':') != -1:
                etape = 'cherche_debut_classe'
                chaine = '{\n'
                fichier_source.write(s)
            else:
                fichier_source.write(s)
        elif etape == 'cherche_debut_classe':
            if string.find(s,chaine)  != -1:
                etape = 'fin'
                fichier_source.write(s)
                # insertion du code
                for s2 in code_a_inserer.readlines():
                    fichier_source.write(s2)
            else:
                fichier_source.write(s)
        elif etape == 'fin':
            fichier_source.write(s)
            
    fichier_source.close()
    fichier_temp.close()
    os.remove('fichier_temp_insert_code_h')
    
# ---------------------------------------------------------------------------------------
# insert_code_cc permet d'inserer du code contenu dans un fichier
# dans une methode sans en supprimer le code deja existant
# Arg_1 : Le fichier a modifie
# Arg_2 : Le fichier a inserer
# Arg_3 : Le nom de la methode
# Retour : Pas de retour
def insert_code_cc(fichier_source_cc, fichier_code, method_name):

    fichier_source = open(fichier_source_cc, 'r')
    code_a_inserer = open(fichier_code, 'r')
    TwinFile(fichier_source_cc, 'fichier_temp_insert_code_cc')
    
    # recherche et insertion du code
    fichier_temp = open('fichier_temp_insert_code_cc','r')
    fichier_source = open(fichier_source_cc, 'wr')
    
    chaine = method_name
    par = -1
    etape = ''
    for s in fichier_temp.readlines():
        if string.find(s,chaine) != -1:
            etape = 'go !!!!'
        if etape == 'go !!!!':
            if string.find(s,'{') != -1:
                if par == -1:
                    par = 0
                par = par + 1
            if string.find(s,'}') != -1:
                par = par - 1
        if par == 0:
            # Decomposition de s
            index = string.find(s,'}')
            s_depart = ''
            if index != 0:
                s_depart = s[:index] + '\n'
            s_fin = s[index:]
            fichier_source.write(s_depart)
            for s2 in code_a_inserer.readlines():
                fichier_source.write(s2)
            fichier_source.write(s_fin)
            etape = ''
            par = -1
        else:
            fichier_source.write(s)
        
    fichier_source.close()
    fichier_temp.close()
    os.remove('fichier_temp_insert_code_cc')

# ---------------------------------------------------------------------------------------
# Cette fonction permet de copier fichier_original dans fichier_de_fin
# en incluant le texte de fichier_a_inclure a la place d'une partie de
# code de fichier_original. Cette partie a exclure va de nom_debut
# jusqu'a nom_fin
def replace_code(fichier_original, fichier_de_fin, fichier_a_inclure, nom_debut, nom_fin):

    fichier_depart = open(fichier_original, 'r')
    fichier_fin = open(fichier_de_fin, 'wr')
    fichier_inclusion = open(fichier_a_inclure, 'r')

    condition = 'false'

    for s in fichier_depart.readlines():
        if condition == 'false':
            if s == nom_test:
                for s2 in fichier_inclusion.readlines():
                    fichier_fin.write(s2)
                condition = 'true'   
            else:
                fichier_fin.write(s)
        else:
            if s == nom_fin:
                condition = 'false'
    fichier_depart.close()
    fichier_fin.close()
    fichier_inclusion.close()
# ---------------------------------------------------------------------------------------
    
# ---------------------------------------------------------------------------------------
# addFileToString permits to add the content of a file in a string
# Arg 1 : the string
# Arg 2 : the file
# Return : the new string
def addFileToString(str, file, modes = []):
    file_add = open(file,'r')
    # Init regex object
    regex_1 = re.compile('!![^!]*!!')
    for s in file_add.readlines():
        result = regex_1.search(s)
	if result:
            end = 'false'
            add = 'false'
            while end == 'false' :
                add_local = 'false'
                macro = result.group()
                macro = macro[2:-2]
                for compteur in modes:
                    if macro == compteur:
                        add_local = 'true'
                if add_local == 'false' :
                    end = 'true'
                else :
                    s = s[result.end():]
                    result = regex_1.search(s)
                    if result:
                        end = 'false'
                    else :
                        add = 'true'
                        end = 'true'
		str = str + s
	else:
	    # s is not a special line
            str = str + s
    file_add.close()
    return str
    
# ---------------------------------------------------------------------------------------
def replace_code_cc(fichier_cource_cc, code, nom_method):

    fichier_source = open(fichier_cource_cc, 'r')
    fichier_temp = open('fichier_temp_insert_code_cc','wr')
    code_a_inserer = open(code, 'r')

    # init : copie du fichier source dans temp
    for s in fichier_source.readlines():
        fichier_temp.write(s)
    fichier_temp.close()
    fichier_source.close()

    # recherche et insertion du code
    fichier_temp = open('fichier_temp_insert_code_cc','r')
    fichier_source = open(fichier_cource_cc, 'wr')
    
    chaine = nom_method

    etape = 'cherche_method'
    for s in fichier_temp.readlines():
        if etape == 'cherche_method':
            if string.find(s,chaine) != -1:
                etape = 'cherche_debut_method'
                chaine = '{\n'
                fichier_source.write(s)
            else:
                fichier_source.write(s)
        elif etape == 'cherche_debut_method':
            if string.find(s,chaine) != -1:
                etape = 'enlever'
                chaine = '}\n'
                fichier_source.write(s)
            else:
                fichier_source.write(s)
        elif etape == 'enlever':
            if string.find(s,chaine) != -1:
                fichier_source.write(s)
                etape = 'fin'
        elif etape == 'fin':
            fichier_source.write(s)
    fichier_source.close()
    fichier_temp.close()

    # on refait une passe
    fichier_temp = open('fichier_temp_insert_code_cc','wr')
    fichier_source = open(fichier_cource_cc, 'r')

    for s in fichier_source.readlines():
        fichier_temp.write(s)
    fichier_temp.close()
    fichier_source.close()

    # recherche et insertion du code
    fichier_temp = open('fichier_temp_insert_code_cc','r')
    fichier_source = open(fichier_cource_cc, 'wr')
    
    chaine = nom_method

    etape = 'cherche_method'
    for s in fichier_temp.readlines():
        if etape == 'cherche_method':
            if string.find(s,chaine) != -1:
                etape = 'insertion'
                chaine = '{\n'
                fichier_source.write(s)
            else:
                fichier_source.write(s)
        elif etape == 'insertion':
            # insertion du code
            fichier_source.write(s)
            for s2 in code_a_inserer.readlines():
                fichier_source.write(s2)
                #print 'insertion ' + s2
                etape = 'fin'
        elif etape == 'fin':
            fichier_source.write(s)
    fichier_source.close()
    fichier_temp.close()
    
    os.remove('fichier_temp_insert_code_cc')
    
#

def create_file(file_name):
    
    chemin = os.environ['PACOPATH']
    file = open(file_name, 'wr')
    file.close()
    concanate_files(file_name, chemin + '/GenFiles/Base/FirstMessage')

def add_include(file_name, file_to_include):

    chemin = os.environ['PACOPATH']
    concanate_files(file_name, chemin + '/GenFiles/Base/Include')
    StringToString(file_name, '@@FILE@@', file_to_include)

def add_using(file_name, package_name):

    chemin = os.environ['PACOPATH']
    concanate_files(file_name, chemin + '/GenFiles/Base/Using')
    StringToString(file_name, '@@NAME@@', package_name)

def add_namespace(file_name, package_name):

    chemin = os.environ['PACOPATH']
    while package_name != '':
        index2 = string.find(package_name, '::')
        package_name_insert = ''
        if index2 == -1 :
            package_name_insert = package_name
            package_name = ''
        else :
            package_name_insert = package_name[:index2]
            package_name = package_name[index2+2:]
        concanate_files(file_name, chemin + '/GenFiles/Base/Namespace')
        StringToString(file_name, '@@NAME@@', package_name_insert)

def add_namespace_end(file_name, package_name):

    chemin = os.environ['PACOPATH']
    while package_name != '':
        index2 = string.find(package_name, '::')
        package_name_insert = ''
        if index2 == -1 :
            package_name_insert = package_name
            package_name = ''
        else :
            package_name_insert = package_name[:index2]
            package_name = package_name[index2+2:]
        concanate_files(file_name, chemin + '/GenFiles/Base/Namespace_end')
        StringToString(file_name, '@@NAME@@', package_name_insert)
    
def add_class(file_name, class_name):
    chemin = os.environ['PACOPATH']
    concanate_files(file_name, chemin + '/GenFiles/Base/Class')
    StringToString(file_name, '@@CLASS_NAME@@', class_name)

def change_method_name(file, before, after):
    
    fichier_source = open(file, 'r')
    fichier_temp = open('fichier_temp_insert_code_cc','wr')

    # init : copie du fichier source dans temp
    for s in fichier_source.readlines():
        fichier_temp.write(s)
    fichier_temp.close()
    fichier_source.close()

    # recherche et insertion du code
    fichier_temp = open('fichier_temp_insert_code_cc','r')
    fichier_source = open(file, 'wr')
    
    for s in fichier_temp.readlines():
        index = string.find(s,before)
        if index != -1:
            s = s[:index] + after
            fichier_source.write(s)
        else:
            fichier_source.write(s)
    os.remove('fichier_temp_insert_code_cc')
    fichier_source.close()
    fichier_temp.close()

def CreateBaseName(package_name, interface_name):
    ret = ''
    if package_name == '':
        ret = interface_name
    else:
        ret = package_name + '::' + interface_name + '::'
    return ret

def addDef(file_name, name):

    temp_file = open('addDef_temp','wr')
    source_file = open(file_name, 'r')
    
    temp_file.write('#ifndef ' + name + '\n')
    temp_file.write('#define ' + name + '\n')

    for s in source_file.readlines():
        temp_file.write(s)

    temp_file.write('#endif\n')
    temp_file.close()
    source_file.close()

    temp_file = open('addDef_temp','r')
    source_file = open(file_name, 'wr')

    for s in temp_file.readlines():
        source_file.write(s)
    temp_file.close()
    source_file.close()
    os.remove('addDef_temp')

    
